from ctypes import *

libc = cdll.LoadLibrary('libc.so.6')
libc

libm = cdll.LoadLibrary('libm.so.6')
libm

#libc.time(None)
#libc.printf(b'good morning world'
#        b', the time is %d\n', libc.time(None))

#i = c_int(42)
#print(i, i.value)
#i.value = -99
#print(i, i.value)

#buf = create_string_buffer(b'hello', 15)
#print(sizeof(buf), repr(buf.raw))
#libc.strcat(buf, b', world')
#print(sizeof(buf), repr(buf.raw))

#libc.printf(b'%d bottles of beer\n', 42)
#libc.printf(b'%f bottles of beer\n', 42.5)
#libc.printf(b'%f bottles of beer\n', c_double(42.5))

#libm.sin(c_double(1))
#libm.sin.restype = c_double
#libm.sin(c_double(1))

#libm.sin.argtypes = [c_double]
#libm.sin(1)

#class PentiumBottles:
#
#    def __init__(self, count):
#        self.count = count
#
#    @property
#    def _as_parameter_(self):
#        return c_double(self.count)
#
#libc.printf(b'there are %f bottles on the wall...\n',
#        PentiumBottles(3.1415926))

#i = c_int()
#f = c_float()
#s = create_string_buffer('\000' * 32)
#print(i.value, f.value, repr(s.value))
#libc.sscanf(b'1 3.14 Hello', b'%d %f %s', byref(i), byref(f), s)
#print(i.value, f.value, repr(s.value))

#class POINT(Structure):
#    _fields_ = [('x', c_double), ('y', c_double)]
#
#point = POINT(10, 20)
#print(point.x, point.y)
#point = POINT(y=5)
#print(point.x, point.y)
#POINT(1, 2, 3)
#
#class RECT(Structure):
#    _fields_ = [('upperleft', POINT), ('lowerright', POINT)]
#
#rc = RECT(point)
#print(rc.upperleft.x, rc.upperleft.y)
#print(rc.lowerright.x, rc.lowerright.y)
#rc = RECT(POINT(1, 2), POINT(3, 4))
#rc = RECT((1, 2), (3, 4))
#
#class CELL(Structure):
#    pass
#CELL._fields_ = [("name", c_char_p), ("next", POINTER(CELL))]

#for i in (POINT * 10)():
#    print(i.x, i. y)

#(c_int*3)(1,2,3)[0]

#i = c_int(10)
#p = pointer(i)
#p.contents
#j = c_int(10)
#p.contents = j
#p.contents.value
#p.contents.value = 11
#j.value
#p[0]

IntArray5 = c_int * 5
int_array = IntArray5(5, 1, 7, 33, 99)
libc.qsort.restype = None

INT_CMP_FUNC = CFUNCTYPE(c_int, POINTER(c_int), POINTER(c_int))

def py_cmp_func(a, b):
    print('py_cmp_func', a, b)
    return 0

def py_cmp_func(a, b):
    print('py_cmp_func', a[0], b[0])
    return 0

def py_cmp_func(a, b):
    print('py_cmp_func', a[0], b[0])
    return a[0] - b[0] 

qsort(ia, len(ia), sizeof(c_int), INT_CMP_FUNC(py_cmp_func))
